#!/usr/bin/ruby
# coding:ISO-8859-1
#-------------------------------------------------------------
#
# Autor: Dr. Heinz Breinlinger
#
#-------------------------------------------------

require 'getoptlong'
require 'win32ole'
require 'fileutils'
#{{{{Globale Variablen
class ExcelConst
end
$cwd=Dir.getwd
$cwd.gsub!(/\//,"\\\\")
$lineHash="#################################################################################################################"
$lineDots=$lineHash.gsub(/#/,"-")
$lineDotsSparse=$lineDots.gsub(/--/,"- ")
$excelWasOpen=false
$excel=nil#}}}}
  def activateProcessWindow(wsh,pid)#{{{{
    begin
      if(wsh.AppActivate(pid))
        puts("Aktiviert: #{pid}")
      else
        die("activateProcessWindow: Could not activate Window for #{pid}")
      end
    rescue => exception
      die("activateProcessWindow: #{exception.message}")
    end
  end#}}}}
  def c2i(text)#{{{{
    begin
      return text.encode("ISO-8859-1","CP850")
    rescue => exception
      die("c2i: #{text} => (#{exception.message})")
    end
  end#}}}}
def checkValue(value)#{{{{
  if(!value)
    puts "checkValue: Value #{value} is not valid .. dying ..."
    finish
  end
end#}}}}
  def readFileRecursively(file)#{{{{
    #------------------------------------------------------------------------------------------------------
    # Liest die angegebene Datei rekursiv (mit allen Includes) ein und gibt den effektiven Inhalt als
    # Array der Zeilen zurueck.
    # Beinhalten die Include-Anweisungen keine Directory-Angabe, wird als Pfad derjenige der uebergebenen
    # Datei angenommen.
    #------------------------------------------------------------------------------------------------------
    begin
      unless(File.exists?(file))
        die("readFileRecursively: Datei #{file} existiert nicht")
      end
      #------------------------------------------------------------------------------------------------------
      # Temporaere Datei erzeugen und mit Inhalten aus <file>, sowie deren Includes fuellen
      #------------------------------------------------------------------------------------------------------
      puts("reading #{file}")
      dirName=File.dirname(file)
      lineArr=Array.new
      File.open(file,"r"){ |inFile|
        while(line=inFile.gets)
          if(line.match(/^include\s+(.+)$/i))
            includeFile=$1
            #------------------------------------------------------------------------------------------------
            # Aktuellen Pfad ergaenzen, sofern keine qualifierte Dateiangabe vorhanden
            #------------------------------------------------------------------------------------------------
            unless(includeFile.match(/^[a-z]:.+/i))
              includeFile=dirName+"\\"+includeFile
            end
            puts("including #{includeFile}")
            #------------------------------------------------------------------------------------------------
            # Rekursiv einlesen und mit Zeilen-Array verknuepfen
            #------------------------------------------------------------------------------------------------
            lineArr.concat(readFileRecursively(includeFile))
          else
            lineArr << line
          end
        end
      }
      return lineArr
    rescue => exception
      die("readFileRecursively: #{exception.message}")
    end
  end#}}}}
def convertExcel(dir=$cwd)#{{{{
#--------------------------------------------------------------------------------------------------
# Konvertiert alle *.xls-Dateien des aktuellen Verzeichnisses in *.xlsx-Format
#--------------------------------------------------------------------------------------------------
begin
  Dir.chdir(dir)
  unless($excel)
    startExcel
  end
  files=Dir.glob("*.xls")
  files.each{ |file|
    qualFile=dir+"\\"+file
    qualNewFile=qualFile+"x"
    #----------------------------------------------------------------------------------------------
    # Zieldatei ggf. loeschen
    #----------------------------------------------------------------------------------------------
    if(File.exists?(qualNewFile))
      FileUtils.rm_f(qualNewFile)
    end
    #--------------------------------------------------------------------------------------------
    # konvertieren ...
    #--------------------------------------------------------------------------------------------
    puts("converting #{qualFile} ...")
    book=$excel.Workbooks.Open(qualFile); checkValue(book)
    book.saveAs(qualNewFile,ExcelConst::XlOpenXMLWorkbook)
    book.close
    unless(File.exists?(qualNewFile))
      die("convertExcel: Konnte #{qualNewFile} nicht erzeugen")
    end
    #--------------------------------------------------------------------------------------------
    # ... und Quelldatei loeschen
    #--------------------------------------------------------------------------------------------
    FileUtils.rm_f(qualFile)
    if(File.exists?(qualFile))
      die("convertExcel: Konnte #{qualFile} nach Konvertierung nicht loeschen")
    end
  }
rescue => exception
  die("convertExcel: #{exception.message}")
ensure
  Dir.chdir($cwd)
end
end#}}}}
def die(message)#{{{{
  puts("Fatal Error: #{message}")
  finish
end#}}}}
def dieFriendly(message)#{{{{
  puts("\n")
  puts("#########################################################################")
  puts("\n")
  puts("#{message}")
  puts("\n")
  puts("#########################################################################")
  puts("\n")
  finish
end#}}}}
def extractYearMonth(date)#{{{{
  #-------------------------------------------------------------
  # Format des uebergebenen Datums:
  #   2014-02-27 00:00:00 +0100
  # Rueckgabe
  #   2014 (Jahr)
  #   02   (Monat)
  #-------------------------------------------------------------
  unless(date.match(/^(\d{4})-(\d{2})/))
    die("extractYearMonth: Ungueltiger Wert #{date}")
  end
  return $1.to_s, $2.to_s
end#}}}}
def finish(smooth=false)#{{{{
  if($excel) 
    if($excelWasOpen)
      if(! smooth)
        puts("closing Excel ...")
        $excel.quit()
      else
        puts("leaving Excel open as before ...")
      end
    else
      puts("closing Excel ...")
      $excel.quit()
    end
  end
  puts("exiting ...")
  exit
end#}}}}
def getProcessIdArray(processName)#{{{{
  #--------------------------------------------------------------------------------------------------
  # Ermittelt aus 'tasklist' alle Prozessnummern zu Prozessname und gibt jene als Array zurueck
  #--------------------------------------------------------------------------------------------------
  begin
    processArray=Array.new
    taskList=%x(tasklist)
    puts("----------------------")
    taskList.split(/\n/).each { |task|
      if(task.match(/^#{processName}\S+\s+(\d+)/))
        puts("Job: #{$1}")
        processArray << $1
      end
    }
    puts("----------------------")
    return processArray
  rescue => exception
    die("getProcessIdArray: #{exception.message}")
  end
end#}}}}
def hashAddFloat(hash,keyArr,floatVal)#{{{{
  #--------------------------------------------------------------------------
  # Naechsten Schluessel entnehmen
  #--------------------------------------------------------------------------
  key=keyArr.shift
  (! key) && die("hashAddFloat: Leerer Schluesselvektor")
  #--------------------------------------------------------------------------
  # Letzter Key ?
  #--------------------------------------------------------------------------
  if(keyArr.length == 0)
    #------------------------------------------------------------------------
    # => Wert einfuegen oder addieren
    #------------------------------------------------------------------------
    if(hash.key?(key))
      hash[key]+=floatVal
    else
      hash[key]=floatVal
    end 
  #--------------------------------------------------------------------------
  # weitere Keys vorhanden
  #--------------------------------------------------------------------------
  else
    #------------------------------------------------------------------------
    # => bei Bedarf neuen Unterhash anlegen und Rekursion
    #------------------------------------------------------------------------
    unless(hash.key?(key))
      hash[key]=Hash.new
    end 
    hashAddFloat(hash[key],keyArr,floatVal)
  end
end#}}}}
def hashGetFloat(hash,keyArr)#{{{{
  #--------------------------------------------------------------------------
  # Naechsten Schluessel entnehmen
  #--------------------------------------------------------------------------
  key=keyArr.shift
  (! key) && die("hashGetFloat: Leerer Schluesselvektor")
  #--------------------------------------------------------------------------
  # Letzter Key ?
  #--------------------------------------------------------------------------
  if(keyArr.length == 0)
    #------------------------------------------------------------------------
    # => Wert oder 0.0 zurueckgeben
    #------------------------------------------------------------------------
    return hash.fetch(key,0.0)
  #--------------------------------------------------------------------------
  # weitere Keys vorhanden
  #--------------------------------------------------------------------------
  else
    #------------------------------------------------------------------------
    # Rekursion, falls Unterhash vorhanden, sonst 0.0 zurueckgeben
    #------------------------------------------------------------------------
    if(hash.key?(key))
      return hashGetFloat(hash[key],keyArr)
    else
      return 0.0
    end
  end
end#}}}}
def hashInsert(hash,key,value,singleton=false)#{{{{
  if(hash.key?(key))
    if(singleton)
      die("Singleton-Verletzung: Hash besitzt Element #{key} bereits")
    end
  else
    hash[key]=value
  end 
end#}}}}
  def i2c(text)#{{{{
    begin
      return text.encode("CP850","ISO-8859-1")
    rescue => exception
      die("i2c: #{text} => (#{exception.message})")
    end
  end#}}}}
  def otherRubyProcessRunning?()#{{{{
    process="ruby.exe"
    begin
      result=%x(tasklist /FI "IMAGENAME eq #{process}" /FI "PID ne #{$$}")
      # result=%x(tasklist /FI "IMAGENAME eq #{process}" /FI "PID ne 04748")
      if(result.match(/#{process}/i))
        return true
      else
        return false
      end
    rescue => exception
      die("otherRubyProcessRunning?: Prozess:#{process}/Fenster:#{title} (#{exception.message})")
    end
  end#}}}}
def pruneDecimals(stringNum)#{{{{
  stringNum=stringNum.to_s
  testNumber(stringNum)
  return stringNum.sub(/(,|\.)\d+/,"") # Aus Stringdarstellung einer Zahl Dezimalstellen abschneiden (Excelartefakt)
end#}}}}
def replaceUmlaute(text)#{{{{
  unless(text.empty?)
    text.gsub!(/&/,"und")
    text.gsub!(//,"ae")
    text.gsub!(//,"oe")
    text.gsub!(//,"ue")
    text.gsub!(//,"Ae")
    text.gsub!(//,"Oe")
    text.gsub!(//,"Ue")
    text.gsub!(//,"ss")
  end
  return text
end#}}}}
  def rubySingleton()#{{{{
    if(otherRubyProcessRunning?)
      dieFriendly("Es laeuft bereits ein anderer Ruby-Prozess => bitte nachher noch mal probieren")
    end
  end#}}}}
def sendKeys(wsh,key,num)#{{{{
  begin
    delay=0.1
    #--------------------------------------------------------------------------------------------
    # Steuertasten in '{}' setzen, space ersetzen
    #--------------------------------------------------------------------------------------------
    if(key.match(/^(clear|delete|down|up|pgdn|pgup|enter|tab)$/i))
      key='{'+key+'}'
    elsif(key.downcase == "tabback")
      key='+{tab}'
    elsif(key.downcase == "space")
      key=' '
    end
    #--------------------------------------------------------------------------------------------
    # Keys senden
    #--------------------------------------------------------------------------------------------
    (1..num).each{ |i|
      puts("#{key}")
      wsh.SendKeys(key)
      sleep(delay)
    }
  rescue => exception
    die("sendKeys: #{exception.message}")
  end
end#}}}}
def startExcel#{{{{
  begin
    puts("trying to connect to Excel ...")
    $excel=WIN32OLE.connect('Excel.Application') 
    $excelWasOpen=true
  rescue
    begin
      puts("... failed => launching Excel ...")
      $excel=WIN32OLE.new('Excel.Application'); checkValue($excel)
    rescue => exception
      die("startExcel: #{exception.message}")
    end
  end 
  $excel.DisplayAlerts=false # verhindert Schlussfrage, ob gespeichert werden soll
  puts("loading Excel-constants ...")
  WIN32OLE.const_load($excel,ExcelConst)
end#}}}}
def startActivateIE#{{{{
  begin
    #------------------------------------------------------------------------------------------
    # wsh-Shell erzeugen
    #------------------------------------------------------------------------------------------
    wsh=startWSH
    #------------------------------------------------------------------------------------------
    # Nummern der bisherigen IE-Prozesse ermitteln
    #------------------------------------------------------------------------------------------
    oldProcesses=getProcessIdArray("iexplore")
    #------------------------------------------------------------------------------------------
    # IE starten
    #------------------------------------------------------------------------------------------
    ie=startIE
    #------------------------------------------------------------------------------------------
    # Neues IE-Fenster anhand dessen Prozessnummer finden.
    # Cave: Real werden bei IE-Start sogar MEHRERE Prozesse erzeugt; Routine hier funktioniert,
    #       da der erste bei numerischer Sortierung der Prozess-IDs gefundene Prozess der
    #       Vaterprozess ist !
    #------------------------------------------------------------------------------------------
    ieId=false
    newProcesses=getProcessIdArray("iexplore")
    newProcesses.sort.each{ |newId|
      unless(oldProcesses.include?(newId))
        ieId=newId
        break
      end
    }
    unless(ieId)
      die("startActivateIE: Could not find new IE-process")
    end
    #------------------------------------------------------------------------------------------
    # ... Fenster des neuen Prozesses aktivieren
    #------------------------------------------------------------------------------------------
    activateProcessWindow(wsh,ieId)
    return ie,ieId,wsh
  rescue => exception
    die("startActivateIE: #{exception.message}")
  end
end#}}}}
def startIE#{{{{
  begin
    puts("launching IE ...")
    ie=WIN32OLE.new('InternetExplorer.Application'); checkValue(ie)
    ie.visible=true
    sleep(3)
    status=ie.ReadyState
    unless(status == 0)
      die("startIE: IE-ReadyState != 0 (#{status})")
    end
    return ie
  rescue => exception
    die("startIE: #{exception.message}")
  end
end#}}}}
def startWSH#{{{{
  begin
    puts("starting WSH-Shell")
    wsh=WIN32OLE.new('WScript.Shell'); checkValue(wsh)
    return wsh
  rescue => exception
    die("startWSH: #{exception.message}")
  end
end#}}}}
def testNumber(var,integer=false)#{{{{
  begin
    #-----------------------------------------------------------------
    # Test auf Integer
    #-----------------------------------------------------------------
    if(integer)
      unless(var.to_s.match(/^\d+$/))
        die("testNumber: #{var} ist keine Ganzzahl")
      end
    #-----------------------------------------------------------------
    # Test auf Float oder Integer
    #-----------------------------------------------------------------
    else
      unless(var.to_s.match(/^\d+(,|\.\d+)?$/))
        die("testNumber: #{var} ist keine Ganz- oder Gleitkommazahl")
      end
    end
  rescue => exception
    die("testNumber: #{exception.message}")
  end
end#}}}}
